from task import *
from thing import *
from copy import copy
class mind(thing):
    "minds: (=npc)"
    current_task=None
    def __init__(self, name, desc='thinking thing', place='home', tasks=[], things=[]):
        thing.__init__(self,name,desc,place)
        self.tasks=copy(tasks)
        self.things={}
        for t in things:
            self.add_thing(t)
    def __str__(self):
        s=thing.__str__(self)+"\n"
        s=s+"current task: "+str(self.current_task)+"\n"
        s=s+"tasks:\n"
        for i in self.tasks: s=s+"    "+str(i)+"\n"
        s=s+"things:\n"
        for j in self.things.values():
            for i in j:
                s=s+"    "+str(i)+"\n"
        return s
    def add_task(self, task): self.tasks.append(task)
    def add_thing(self,thing1): 
            try:
                self.things[thing1.name].append(thing1)
            except KeyError:
                self.things[thing1.name]=[thing1]
    def find_task(self,time):
        importance=None
        for a in self.tasks:
            if time==a.time and cmp_importance(importance,a.importance)<=0:
                importance=a.importance
                self.current_task=a
    def check_objects(self,objects):
        for i in range(len(objects[0])):
            #Is task associated with required object?
            if len(objects[1])<=i:
                try:
                    t=self.things[objects[0][i]][0]
                    objects[1].append(t)
                    #Is it within person?
                    if t.place!=self.name:
                        print self.name, "gets", t
                        t.place=self.name
                except KeyError:
                    pass
    def run_step(self,time):
        """run one time step:
           decide what is most important task and do it"""
        self.find_task(time)
        objects=self.current_task.required_things()
        self.check_objects(objects)
        self.place=self.current_task.place
        self.current_task.do()
