#!/usr/bin/python -i

from task import *
from mind import *
from world import *

peasant_tasks=[
    task('have a breakfast', 'morning', 'home', action('eat')),
    task('have a dinner', 'midday', 'home', action('eat')),
    task('have a supper', 'evening', 'home', action('eat')),
    task('sleep good night', 'night', 'home', action('sleep'))]


farmer=mind('farmer','ordinary farmer','home',peasant_tasks)
farmer.add_task(task('sow field', 'spring', 'field'))
farmer.add_task(task('tend fields', 'summer', 'field'))
farmer.add_task(task('harvest crop', 'autumn', 'field'))

class axe(thing):
    def use(self):
        self.status[0]=self.status[0]-0.1

class cut_trees_action(action):
    def do(self):
        self.objects[0].use()

cut_trees=cut_trees_action('chop trees for various purposes',['axe'],)
farmer.add_task(task('chop trees', 'winter', 'forest',cut_trees))
farmer.add_thing(axe('axe','normal axe good for cutting trees','home',[1.0]))

smith=mind('smith','only smith in village','home',peasant_tasks)
smith.add_task(task('forge tools', 'always','smithy'))

w=world()
w.add_mind(farmer)
w.add_mind(smith)

def p(o): print o
def r(steps=1):
    for i in range(steps): w.run_step();
    p(w.time);
    for npc in w.minds:
        p(npc.name); p(npc.place); p(npc.current_task)
